## agda 2.3.2.2

=== Makefile ===
# Top-level Makefile for Agda 2
# Authors: Ulf Norell, Nils Anders Danielsson

SHELL=bash
## Includes ###############################################################

TOP = .

is_configured = $(shell if test -f mk/config.mk; \
						then echo Yes; \
						else echo No; \
						fi \
				 )

include mk/paths.mk

ifeq ($(is_configured),Yes)
include mk/config.mk
include mk/rules.mk
endif


## Phony targets ##########################################################

.PHONY : default all clean install full prof core \
		 debug doc dist make_configure clean_test examples \
		 test tests succeed fail interaction benchmark up-to-date-std-lib \
		 update-cabal install-lib install-bin install-emacs-mode

## Default target #########################################################

ifeq ($(is_configured),Yes)
default : compile-emacs-mode
# tags
else
default : make_configure
endif

## Cabal-based installation ###############################################

# The cabal command.
CABAL_CMD=cabal

# Options used by cabal install.
CABAL_OPTIONS=
#  -f epic

install : update-cabal install-bin compile-emacs-mode setup-emacs-mode

prof : install-prof-bin

update-cabal :
	$(CABAL_CMD) update

# Installs the Emacs mode, but does not set it up.
install-bin :
	$(CABAL_CMD) install --disable-library-profiling --disable-documentation $(CABAL_OPTIONS)

install-prof-bin :
	$(CABAL_CMD) install --enable-library-profiling --enable-executable-profiling \
                             --program-suffix=_p --disable-documentation $(CABAL_OPTIONS)

compile-emacs-mode : install-bin
	agda-mode compile

setup-emacs-mode : install-bin
	@echo
	@echo "If the agda-mode command is not found, make sure that the directory"
	@echo "in which it was installed is located on your shell's search path."
	@echo
	agda-mode setup

## Making the make system #################################################

m4_macros	= $(wildcard $(MACRO_DIR)/*.m4)

make_configure : configure
	@echo "Run './configure' to set up the build system."

configure : aclocal.m4 $(m4_macros) configure.ac
	autoconf

##
## The following targets are only available after running configure #######
##

ifeq ($(is_configured),Yes)

## Making the documentation ###############################################

doc :
	$(MAKE) -C $(HADDOCK_DIR)

## Making the full language ###############################################

ifeq ($(HAVE_RUNHASKELL),Yes)

SETUP	   = Setup.hs
RUNSETUP   = $(RUNHASKELL) $(SETUP)

else

SETUP	   = setup
RUNSETUP   = ./setup

$(SETUP) : Setup.hs
	ghc --make -o $@ $<

endif

CONFIG	= dist/setup-config
CABAL		= Agda.cabal
BUILD		= dist/build-complete
INPLACE = dist/installed-inplace
SOURCES = $(shell $(FIND) $(FULL_SRC_DIR) -name '*hs') \
					$(shell $(FIND) $(FULL_SRC_DIR) -name '*.y') \
					$(shell $(FIND) $(FULL_SRC_DIR) -name '*.x')

$(CONFIG) : $(CABAL) $(SETUP)
	$(RUNSETUP) configure

$(BUILD) : $(CONFIG) $(SOURCES)
	$(RUNSETUP) build
	@date > $@

$(INPLACE) : $(BUILD)
	$(RUNSETUP) register --user --inplace
	@date > $@

$(AGDA_BIN) : $(INPLACE) $(MAIN_SRC_DIR)/Main.hs
	$(MAKE) -C $(MAIN_SRC_DIR)

full : $(AGDA_BIN)

## Making the core language ###############################################

core :
	$(MAKE) -C $(CORE_SRC_DIR)

## Making the Agda 1 to Agda 2 translator #################################

transl :
	(cd $(TRANSL_SRC_DIR); cabal configure && cabal build)

## Making the source distribution #########################################

ifeq ($(HAVE_DARCS)-$(shell if test -d _darcs; then echo darcs; fi),Yes-darcs)
  is_darcs_repo = Yes
else
  is_darcs_repo = No
endif

ifeq ($(is_darcs_repo),Yes)

dist : agda2.tar.gz

agda2.tar.gz :
	$(DARCS) dist -d agda2

else

dist :
	@echo You can only "'make dist'" from the darcs repository.
	@$(FALSE)

endif

tags :
	$(MAKE) -C $(FULL_SRC_DIR) tags
TAGS :
	$(MAKE) -C $(FULL_SRC_DIR) TAGS

## Testing ###########################################################

test : check-whitespace succeed fail interaction examples tests library-test compiler-test lib-succeed epic-test

tests :
	@echo "======================================================================"
	@echo "======================== Internal test suite ========================="
	@echo "======================================================================"
	$(AGDA_BIN) --test

succeed :
	@echo "======================================================================"
	@echo "===================== Suite of successfull tests ====================="
	@echo "======================================================================"
	@chmod +x test/succeed/checkOutput
	@$(MAKE) -C test/succeed

interaction :
	@echo "======================================================================"
	@echo "===================== Suite of interaction tests ====================="
	@echo "======================================================================"
	@$(MAKE) -C test/interaction

examples :
	@echo "======================================================================"
	@echo "========================= Suite of examples =========================="
	@echo "======================================================================"
	@$(MAKE) -C examples

fail :
	@echo "======================================================================"
	@echo "======================= Suite of failing tests ======================="
	@echo "======================================================================"
	@$(MAKE) -C test/fail

std-lib :
	darcs get --lazy --repo-name=$@ \
		 http://www.cse.chalmers.se/~nad/repos/lib/

up-to-date-std-lib : std-lib
	@(cd std-lib && darcs pull -a && make setup)

library-test : up-to-date-std-lib
	@echo "======================================================================"
	@echo "========================== Standard library =========================="
	@echo "======================================================================"
	@(cd std-lib && \
          time $(PWD)/$(AGDA_BIN) -i. -isrc README.agda $(AGDA_TEST_FLAGS) \
            +RTS -s)

compiler-test : up-to-date-std-lib
	@echo "======================================================================"
	@echo "============================== Compiler =============================="
	@echo "======================================================================"
	@(cd test/compiler && \
          time ../../$(AGDA_BIN) --compile -i. -i../../std-lib -i../../std-lib/src \
            Main.agda +RTS -H1G -M1.5G && \
          ./Main)

lib-succeed :
	@echo "======================================================================"
	@echo "========== Successfull tests using the standard library =============="
	@echo "======================================================================"
	@$(MAKE) -C test/$@

epic-test :
	@echo "======================================================================"
	@echo "============================ Epic backend ============================"
	@echo "======================================================================"
	@$(MAKE) -C test/epic

benchmark :
	@$(MAKE) -C benchmark

## Clean ##################################################################

clean :
	$(MAKE) -C $(HADDOCK_DIR) clean
	rm -rf $(OUT_DIR)
	rm -rf dist

veryclean :
	$(MAKE) -C $(HADDOCK_DIR) veryclean
	rm -rf $(OUT_DIR)
	rm -rf configure config.log config.status autom4te.cache mk/config.mk

## Debugging the Makefile #################################################

info :
	@echo "The agda binary is at:         $(AGDA_BIN)"
	@echo "Do we have ghc 6.4?            $(HAVE_GHC_6_4)"
	@echo "Is this the darcs repository?  $(is_darcs_repo)"

else	# is_configured

info :
	@echo "You haven't run configure."

endif	# is_configured

## Whitespace-related #####################################################

# Agda can fail to compile on Windows if files which are CPP-processed
# don't end with a newline character (because we use -Werror).

.PHONY:
fix-whitespace :
	fix-agda-whitespace

.PHONY:
check-whitespace :
	fix-agda-whitespace --check

.PHONY:
install-fix-agda-whitespace :
	cd src/fix-agda-whitespace && \
	$(CABAL_CMD) install $(CABAL_OPTIONS)

=== benchmark/Makefile ===

AGDA = agda

include tests.mk

TAG			= $(shell echo `date +"%Y%m%d-%H.%M"`-`hostname -s`)
LOG_DIR = logs
PROC_INFO = $(shell which procinfo)
HOST_INFO = $(shell which hostinfo)

ifeq ($(HOST_INFO),)
ifeq ($(PROC_INFO),)
INFO = echo "No info"
else
INFO = $(PROC_INFO)
endif
else
INFO = $(HOST_INFO)
endif

logDir = $(LOG_DIR)/$(TAG)
logFiles = $(patsubst %,$(logDir)/%,$(allTests))

verbose = -v0 -v profile:100

all : clean $(logDir) $(logFiles)

$(logDir) :
	@mkdir -p $@

$(LOG_DIR)/$(TAG)/% :
	@echo Running benchmark $*
	@$(AGDA) $(verbose) $($*) +RTS -slogs/.tmp > $@
	@cat logs/.tmp >> $@
	@rm logs/.tmp
	@echo "──────────────────────────────────────────────────────────────────" >> $@
	@$(INFO) >> $@

clean :
	@find . -name '*.agdai' -exec rm {} \;

=== examples/Makefile ===

TOP = ..

include $(TOP)/mk/paths.mk
include $(TOP)/mk/config.mk

default : test polydep hello path regexp-talk aim4-bag ac effects minmax real view simplelib lib divmod highlighting malonzo relocatable-interfaces malformed-interfaces term1 term2 term3 html1 html2 epic

agda = $(AGDA_BIN)

run_agda = $(agda) -v0 --vim $(AGDA_TEST_FLAGS)

test_files = Vec.agda Lookup.agda Binary.agda Setoid.agda \
			 TT.agda ISWIM.agda ParenDepTac.agda \
			 AIM5/Hedberg/SET.agda AIM5/yoshiki/SET.agda \
			 SimpleTypes.agda Monad.agda Miller/Pat.agda \
       syntax/Literate.lagda Termination/StreamEating.agda \
	instance-arguments/01-arguments.agda \
	instance-arguments/02-classes-indep.agda \
	instance-arguments/04-equality.agda \
	instance-arguments/06-listEquality.agda \
	instance-arguments/08-higherOrder.agda \
	instance-arguments/14-implicitConfigurations.agda
# the other instance-arguments examples use the standard library,
# seemingly no way to include it during test run...
tests	   = $(patsubst %,%.test,$(test_files))

echo = $(shell which echo)
ifeq ("$(echo)","")
echo = echo
endif

term1 : Termination/Mutual.agda
	@$(echo) "Testing $<... "
	@$(echo) :q | $(run_agda) -iTermination $<
	@$(echo) "ok"

term2 : Termination/StructuralOrder.agda
	@$(echo) "Testing $<... "
	@$(echo) :q | $(run_agda) -iTermination $<
	@$(echo) "ok"

term3 : Termination/Tuple.agda
	@$(echo) "Testing $<... "
	@$(echo) :q | $(run_agda) -iTermination $<
	@$(echo) "ok"

polydep : AIM5/PolyDep/Main.agda
	@$(echo) "Testing $<... "
	@$(echo) :q | $(run_agda) -iAIM5/PolyDep $<
	@$(echo) "ok"

hello : AIM6/HelloAgda/Everything.agda
	@$(echo) "Testing $<... "
	@$(echo) :q | $(run_agda) -iAIM6/HelloAgda $<
	@$(echo) "ok"

path : AIM6/Path/All.agda
	@$(echo) "Testing $<... "
	@$(echo) :q | $(run_agda) -iAIM6/Path $<
	@$(echo) "ok"

regexp-talk : AIM6/RegExp/talk/Everything.agda
	@$(echo) "Testing $<... "
	@$(echo) :q | $(run_agda) -iAIM6/RegExp/talk $<
	@$(echo) "ok"

aim4-bag : AIM4/bag/Bag.agda
	@$(echo) "Testing $<... "
	@$(echo) :q | $(run_agda) -iAIM4/bag $<
	@$(echo) "ok"

ac : tactics/ac/AC.agda
	@$(echo) "Testing $<... "
	@$(echo) :q | $(run_agda) -itactics/ac $<
	@$(echo) "ok"

effects : sinatra/Example.agda
	@$(echo) "Testing $<..."
	@$(echo) :q | $(run_agda) -isinatra $<
	@$(echo) "ok"

minmax : order/MinMax.agda
	@$(echo) "Testing $<... "
	@$(echo) :q | $(run_agda) -ilib -iorder $<
	@$(echo) "ok"

real : lib/Data/Real/CReal.agda
	@$(echo) "Testing $<... "
	@$(echo) :q | $(run_agda) -ilib $<
	@$(echo) "ok"

view : vfl/Typechecker.agda
	@$(echo) "Testing $<... "
	@$(echo) :q | $(run_agda) -ivfl $<
	@$(echo) "ok"

simplelib : simple-lib/TestLib.agda
	@$(echo) "Testing $<... "
	@$(echo) :q | $(run_agda) -isimple-lib $<
	@$(echo) "ok"

lib : lib/Test.agda
	@$(echo) "Testing $<... "
	@$(echo) :q | $(run_agda) -ilib $<
	@$(echo) "ok"

divmod : arith/DivMod.agda
	@$(echo) "Testing $<... "
	@$(echo) :q | $(run_agda) -iarith -isimple-lib $<
	@$(echo) "ok"

intro : Introduction/All.agda
	@$(echo) "Testing $<... "
	@$(echo) :q | $(run_agda) $<
	@$(echo) "ok"

highlighting : syntax/highlighting/Test*agda
	@$(echo) "Testing $^... "
	@$(echo) :q | $(run_agda) --vim -isyntax/highlighting syntax/highlighting/Test2.agda
	@$(echo) :q | $(run_agda) --vim -isyntax/highlighting syntax/highlighting/Test3.lagda
	@$(echo) "ok"

malonzo : compiler/main.agda
	@$(echo) "Testing the MAlonzo backend"
	@$(agda) --ignore-interfaces --compile --compile-dir=compiler -icompiler $<
	@./compiler/main
        # Compilation works also if the code has already been type
        # checked.
	@rm -rf compiler/main compiler/MAlonzo
	@$(agda) --compile --compile-dir=compiler -icompiler $<
	@./compiler/main
	@$(echo) "ok"

epic : compiler/main.agda
	@$(echo) "Testing the Epic backend"
	@$(agda) --ignore-interfaces --epic --compile-dir=compiler -icompiler $<
	@./compiler/main
        # Compilation works also if the code has already been type
        # checked.
	@rm -rf compiler/main compiler/Epic
	@$(agda) --epic --compile-dir=compiler -icompiler $<
	@./compiler/main
	@$(echo) "ok"

relocatable-interfaces : relocatable/originals/*.agda
	-@rm -rf relocatable/copies
	@$(echo) "Testing that interface files are relocatable"
	@$(agda) --ignore-interfaces -irelocatable/originals relocatable/originals/C.agda
	@cp -pR relocatable/originals relocatable/copies
	@sleep 1
	@touch relocatable/copies/B.agda
	@sleep 2
        # Type checking succeeds...
	@$(agda) -irelocatable/copies relocatable/copies/C.agda > relocatable/copies/output
	@cat relocatable/copies/output
        # ...and skips one of the modules (A).
	@[ `grep "^ *Skipping" relocatable/copies/output | wc -l` = 1 ]
	@rm -rf relocatable/copies

malformed-interfaces : malformed/Empty.agda
	@$(echo) "Testing that Agda can handle at least some malformed interface files."
	@echo > malformed/Empty.agdai
	@$(agda) -imalformed malformed/Empty.agda
	-@openssl rand -out malformed/Empty.agdai 1024 2> /dev/null
	@$(agda) -imalformed malformed/Empty.agda
	@echo apa >> malformed/Empty.agdai
	@$(agda) -imalformed malformed/Empty.agda

html1 : AIM6/RegExp/talk/Everything.agda
	@$(echo) "Testing HTML generation in the default directory"
	@$(run_agda) --html -iAIM6/RegExp/talk $<
	@[ -e html/Everything.html ]
	@rm -rf html
	@$(echo) "ok"

html2 : AIM6/RegExp/talk/Everything.agda
	@$(echo) "Testing HTML generation in a particular directory"
	@$(run_agda) --html --html-dir=HTML -iAIM6/RegExp/talk $<
	@[ -e HTML/Everything.html ]
	@rm -rf HTML
	@$(echo) "ok"

test : $(tests)

$(tests) : %.test : %
	@$(echo) -n "Testing $<... "
	@$(echo) :q | $(run_agda) -i$(dir $<) $<
	@$(echo) "ok"

=== benchmark/ac/Makefile ===

TOP = ../..
include $(TOP)/mk/paths.mk

agda = $(AGDA_BIN)

ac1 = AC.agda --ignore-interfaces
ac2 = Example.agda --ignore-interfaces
ac3 = Example.agda

foo-% :
	echo $($*)

all : test1-$(SUFFIX) test2-$(SUFFIX) test3-$(SUFFIX)

$(LOG_DIR)/%-$(SUFFIX) :
	$(agda) $($*) +RTS -s$@
	@echo "──────────────────────────────────────────────────────────────────" >> $@
	@hostinfo >> $@

=== doc/haddock/Makefile ===
# Making the haddock documentation
# Author: Ulf Norell

## Includes ###############################################################

TOP = ../..

include $(TOP)/mk/config.mk
include $(TOP)/mk/paths.mk

## Variables ##############################################################

# Haddock interface for the base package
haddockURL	= http://www.haskell.org/ghc/docs/$(GHC_VERSION)/html/libraries
haddockArg	= $(haddockURL)/$(1),$(1).haddock
haddockFile = $(haddockURL)/$(1)/$(1).haddock

# Haskell files
lexer			= Syntax/Parser/Lexer
parser			= Syntax/Parser/Parser
gen_hs_files	= $(FULL_OUT_DIR)/$(lexer).hs $(FULL_OUT_DIR)/$(parser).hs
src_hs_files	= $(shell $(FIND) $(FULL_SRC_DIR) -name '*.hs' -o -name '*.lhs')
dst_hs_files	= $(patsubst $(FULL_SRC_DIR)/%,src/%,$(src_hs_files)) \
				  $(patsubst $(FULL_OUT_DIR)/%,src/%,$(gen_hs_files))

# The prologue. Contains an introduction to the documentation
prologue		= prologue

## Phony targets ##########################################################

.PHONY : default clean veryclean debug check_version

## Default target #########################################################

ifeq ($(HAVE_HADDOCK),Yes)

default : index.html

else

default :
	@echo You need haddock to build this documentation.
	@$(FALSE)

endif

## Base file ##############################################################

ifeq ($(HAVE_WGET),Yes)

%.haddock :
	wget $(call haddockFile,$*)

else

%.haddock :
	@echo $(call haddockFile,$*) have to be downloaded manually since wget could not be found.
	@$(FALSE)

endif

## Preprocessing Haskell files ############################################

# Haddock cannot handle circular module dependencies or C preprocessor
# directives in Haskell code, so we have to let ghc preprocess the source
# files before giving them to haddock. To handle circular module
# dependencies surround the boot file imports with an
# #ifndef __HADDOCK__
# It might also be necessary to define a dummy version of types imported
# from boot files as follows:

# #ifndef __HADDOCK__
# import Foo (X)
# #endif
# ...
# #ifdef __HADDOCK__
# -- | Trick to make haddock accept circular module dependencies. See 'Foo.X'.
# data X
# #endif

# There is no need to do this for functions since they cannot appear in
# types, and thus not in haddock documentation.

src/% : $(FULL_SRC_DIR)/% src
	@echo Preprocessing $* for haddock
	@$(MKDIR) -p $(dir $@)
	@$(GHC) -E -optP-P -optP-I$(FULL_SRC_DIR) -D__HADDOCK__ -o $@ $<

src/% : $(FULL_OUT_DIR)/% src
	@echo Preprocessing $* for haddock
	@$(MKDIR) -p $(dir $@)
	@$(GHC) -E -optP-P -optP-I$(FULL_SRC_DIR) -D__HADDOCK__ -o $@ $<

src :
	$(MKDIR) -p src

$(FULL_OUT_DIR)/$(parser).hs : $(FULL_SRC_DIR)/$(parser).y
	@$(MAKE) -C $(FULL_SRC_DIR) $@

$(FULL_OUT_DIR)/$(lexer).hs : $(FULL_SRC_DIR)/$(lexer).x
	@$(MAKE) -C $(FULL_SRC_DIR) $@

## Building the haddock documentation #####################################

# It would be nice to check which version of haddock the ghc library
# documentation is built with, but I don't know how (in an easy way).
# For now it's hard-wired.
ifeq ($(HAVE_GHC_6_4),Yes)
base_interface_version = 0.7
else
base_interface_version = 0.6
endif

ifeq ($(HADDOCK_VERSION),$(base_interface_version))
check_version :
else
check_version :
	@echo "Warning: The ghc library documentation was probably"
	@echo "         built using version $(base_interface_version) of haddock, but you"
	@echo "         are using version $(HADDOCK_VERSION). Haddock might not be"
	@echo "         able to link to library definitions."
endif

index.html : $(prologue) $(dst_hs_files) base.haddock mtl.haddock check_version 
	$(HADDOCK) --odir=. --html \
			--prologue=$(prologue) \
			--title="Agda II Documentation" \
			--ignore-all-exports \
			--read-interface=$(call haddockArg,base) \
			--read-interface=$(call haddockArg,mtl) \
			$(dst_hs_files)

## Clean ##################################################################

clean :
	rm -rf $(wildcard *.html) src haddock.css haskell_icon.gif

veryclean : clean
	rm -f base.haddock

## Debugging the Makefile #################################################

debug :
	@echo The Haskell sources are
	@echo "  $(src_hs_files)"
	@echo The preprocessed files are
	@echo "  $(dst_hs_files)"

=== notes/typechecking/Makefile ===

default : algorithm.ps algorithm.pdf

%.dvi : %.tex
	latex --interaction=nonstopmode $<
	latex --interaction=nonstopmode $<

%.pdf : %.tex
	pdflatex $<

%.ps : %.dvi
	dvips -o $@ $<

=== src/core/Makefile ===
# Makefile for the core language implementation
# Author: Ulf Norell

## Includes ###############################################################

TOP = ../..

include $(TOP)/mk/config.mk
include $(TOP)/mk/paths.mk

## Directories ############################################################

OUT	= $(CORE_OUT_DIR)
OUT_P	= $(CORE_OUT_DIR)/prof

## Phony targets ##########################################################

.PHONY : default clean

## Default target #########################################################

default : $(OUT)/agdacore

## Files ##################################################################

gen_hs_files = $(OUT)/Core/Par.hs $(OUT)/Core/Lex.hs $(OUT)/Core/Abs.hs \
				$(OUT)/Core/Print.hs
all_hs_files = $(shell $(FIND) . -name '*hs') $(gen_hs_files)

## Creating the output directory structure ################################

dirs		= $(shell $(FIND) . -type d -not -name CVS)
out_dirs	= $(patsubst .%,$(OUT)%,$(dirs))
out_dirs_p	= $(filter-out .,$(patsubst .%,$(OUT_P)%,$(dirs)))

$(out_dirs) $(out_dirs_p) :
	$(MKDIR) -p $@

## Boot files pre 6.4 #####################################################

# Before ghc 6.4 you wrote hi-boot files. In 6.4 you write hs-boot files
# which ghc compiles into hi-boot files (with a very different format from
# the ones you wrote by hand). So if we are compiling with a pre-6.4 ghc
# we have to copy the hand-written hi-boot files to the out directory.

ifeq ($(HAVE_GHC_6_4),No)

src_hi_boot_files	= $(shell $(FIND) . -name '*.hi-boot')
hi_boot_files		= $(patsubst ./%,$(OUT)/%,$(src_hi_boot_files))
hi_boot_files_p		= $(patsubst ./%,$(OUT_P)/%,$(src_hi_boot_files))

$(OUT)/%.hi-boot : $(hi_boot_files) : %.hi-boot
	cp $< $@

$(OUT_P)/%.hi-boot : $(hi_boot_files_p) : %.hi-boot
	cp $< $@

endif

## Compiling agda #########################################################

GHC_FLAGS += -fno-warn-incomplete-patterns -fno-warn-overlapping-patterns

$(OUT)/agdacore : $(out_dirs) $(all_hs_files) $(hi_boot_files)
	$(GHC) --make -o $@ -odir $(OUT) -hidir $(OUT) -i$(OUT) $(GHC_FLAGS) Main.hs

$(OUT_P)/agdacore : $(out_dirs_p) $(all_hs_files) $(hi_boot_files_p)
	$(GHC) --make -o $@ -odir $(OUT_P) -hidir $(OUT_P) -i$(OUT) $(GHC_FLAGS) Main.hs -prof -auto-all

## BNFC rules #############################################################

$(OUT)/%/Par.y $(OUT)/%/Lex.x $(OUT)/%/Abs.hs : %.cf
	bnfc -haskell -d $<
	-rm -rf $(OUT)/$*
	mv $* $(OUT)

## Rules for happy and alex ###############################################

%.hs : %.x
	$(ALEX) $(ALEX_FLAGS) $< -o $@

%.hs : %.y
	$(HAPPY) $(HAPPY_FLAGS) --info=$*.happy.out $< -o $@

## Clean ##################################################################

clean :
	rm -f $(generated_files)

veryclean : clean

debug :
	@echo $(out_dirs)

=== src/full/Makefile ===
# Makefile for full language.
# Author:  Ulf Norell

## Includes ###############################################################

TOP = ../..

include $(TOP)/mk/config.mk
include $(TOP)/mk/paths.mk

## Directories ############################################################

OUT		= $(FULL_OUT_DIR)
OUT_P	= $(FULL_OUT_DIR)/prof

## Source files ###########################################################

src_files		= $(patsubst ./%,%,$(shell $(FIND) . -name '*.hs' -o -name '*.lhs'))
all_hs_files	= $(src_files) $(OUT)/Agda/Syntax/Parser/Parser.hs \
							   $(OUT)/Agda/Syntax/Parser/Lexer.hs
all_hs_files_p	= $(src_files) $(OUT_P)/Agda/Syntax/Parser/Parser.hs \
							   $(OUT_P)/Agda/Syntax/Parser/Lexer.hs

h_files			= undefined.h
out_h_files		= $(patsubst %,$(OUT)/%,$(h_files))
out_p_h_files	= $(patsubst %,$(OUT_P)/%,$(h_files))

## Phony targets ##########################################################

.PHONY : default clean prof

## Default target #########################################################

default : $(OUT)/agda

## Creating the output directory structure ################################

dirs		= $(shell $(FIND) . -type d -not -name CVS)
out_dirs	= $(filter-out .,$(patsubst ./%,$(OUT)/%,$(dirs)))
out_dirs_p	= $(filter-out .,$(patsubst ./%,$(OUT_P)/%,$(dirs)))

$(out_dirs) $(out_dirs_p) :
	$(MKDIR) -p $@

## Boot files #############################################################

# hs-boot files have to be in the same place as the corresponding hs file.
# Thus we have to copy the boot files for the generated files (Lexer and
# Parser) to the out directiory.

boot_files = $(OUT)/Agda/Syntax/Parser/Lexer.hs-boot
boot_files_p = $(OUT_P)/Agda/Syntax/Parser/Lexer.hs-boot

$(OUT)/% : %
	@cp $< $@

$(OUT_P)/% : %
	@cp $< $@

## Header files ###########################################################

$(out_h_files) : $(OUT)/%.h : %.h
	@cp $< $@

$(out_p_h_files) : $(OUT_P)/%.h : %.h
	@cp $< $@

## Compatibility ##########################################################

# If we don't have ghc-6.6 we need to supply some of the libraries.

ifeq ($(HAVE_GHC_6_6),No)

GHC_FLAGS += -i$(COMPAT_SRC_DIR)

endif

## Compiling agda #########################################################

prof : $(OUT_P)/agda

GHC_FLAGS += -package QuickCheck-1.0

$(OUT)/agda : $(out_dirs) $(out_h_files) $(all_hs_files) $(boot_files)
	$(GHC) --make -o $@ -i$(OUT) -I. -odir $(OUT) -hidir $(OUT) $(GHC_FLAGS) Main.hs

$(OUT_P)/agda : $(out_dirs_p) $(out_p_h_files) $(all_hs_files_p) $(boot_files_p)
	$(GHC) --make -o $@ -i$(OUT_P) -I. -odir $(OUT_P) -hidir $(OUT_P) $(GHC_FLAGS) Main.hs -prof -auto-all

## Rules for happy and alex ###############################################

$(OUT)/%.hs : %.x
	$(ALEX) $(ALEX_FLAGS) -o $@ $<

$(OUT)/%.hs : %.y
	$(HAPPY) $(HAPPY_FLAGS) -o $@ --info=$(OUT)/$*.happy.out $<

$(OUT_P)/%.hs : %.x
	$(ALEX) $(ALEX_FLAGS) -o $@ $<

$(OUT_P)/%.hs : %.y
	$(HAPPY) $(HAPPY_FLAGS) -o $@ --info=$(OUT_P)/$*.happy.out $<

## Tags ###################################################################

hTags=../hTags/dist/build/hTags/hTags
hTags_include=../../dist/build/autogen/cabal_macros.h

$(hTags) :
	$(MAKE) -C ../hTags

# create tags for VIM
tags : $(src_files) $(hTags) $(hTags_include)
	$(hTags) -i$(hTags_include) -c $(src_files)

# create tags for emacs
TAGS : $(src_files) $(hTags) $(hTags_include)
	$(hTags) -i$(hTags_include) -e $(src_files)

# Andreas: create tags for everything exept Auto and Compilers
ignore = $(patsubst ./%,%,$(shell $(FIND) ./Agda/Auto ./Agda/Compiler -name '*.hs' -o -name '*.lhs'))
tag_files = $(filter-out $(ignore),$(src_files))

mytags :  $(tag_files) $(hTags) $(hTags_include)
	$(hTags) -i$(hTags_include) -e $(tag_files)

=== src/hTags/Makefile ===

sources = $(shell find . -name '*hs')
bin			= dist/build/hTags/hTags
setup		= dist/setup-config

.PHONY : default

default : $(bin)

$(setup) : hTags.cabal
	cabal configure

$(bin) : $(setup) $(sources)
	cabal build

=== src/main/Makefile ===

TOP=../..

include $(TOP)/mk/paths.mk
include $(TOP)/mk/config.mk
include $(TOP)/mk/rules.mk

src_files = $(shell $(FIND) $(FULL_SRC_DIR) -name '*hs') \
						$(shell $(FIND) $(FULL_SRC_DIR) -name '*.x') \
						$(shell $(FIND) $(FULL_SRC_DIR) -name '*.y')

default : $(AGDA_BIN)

CONFIGURED = dist/.configured

AGDA_BIN_P = dist/build/agda/agda_p

$(CONFIGURED) : Agda-executable.cabal ../../Agda.cabal
	$(RUNSETUP) configure --user
	@touch $@

.uptodate : $(src_files)	
	@echo Rebuilding executable...
	@rm -f $(AGDA_BIN) $(AGDA_BIN_P)
	@touch .uptodate

$(AGDA_BIN) : Main.hs $(CONFIGURED) .uptodate
	$(RUNSETUP) build

prof : $(AGDA_BIN_P)

$(AGDA_BIN_P) : Main.hs .uptodate
	$(GHC) --make Main.hs -O -prof -auto-all -o $@

=== src/rts/Makefile ===

.PHONY : default

.setup-config : agda-rts.cabal Setup.hs RTP.hs RTN.hs RTS.hs
	runhaskell Setup.hs configure

default : .setup-config
	runhaskell Setup.hs build
	runhaskell Setup.hs register --user --inplace

=== test/epic/Makefile ===
test:
	-rm -r Epic
	-rm -r tests/bin
	mkdir tests/bin
	agda --epic RunTests.agda
	./RunTests

## agda 2.2.6

=== debian/changelog ===
agda (2.2.6-7) unstable; urgency=low

  * control: Use versioned Replaces: and Conflicts:

 -- Marco Túlio Gontijo e Silva <marcot@debian.org>  Wed, 05 May 2010 23:13:56 -0300

agda (2.2.6-6) unstable; urgency=low

  * Fix FTBFS by fixing zlib doc package name. (Closes: #577892)
  * Convert to 3.0 (quilt)

 -- Joachim Breitner <nomeata@debian.org>  Fri, 16 Apr 2010 11:43:24 +0200

agda (2.2.6-5) unstable; urgency=low

  * debian/control: Rename -doc package.

 -- Marco Túlio Gontijo e Silva <marcot@debian.org>  Tue, 16 Mar 2010 10:15:20 -0300

agda (2.2.6-4) unstable; urgency=low

  * debian/control: Remove the profiling package. It is unfortunate that this
    package is proving to be too big to build before exhausting the available
    resources on some architectures. Not having it should allow agda to build
    in many more places though, so this is a win.
  * debian/control, debian/rules, debian/watcher.sh: Remove the ticker which
    should no longer be necessary due to the above. (Closes: #572300)

 -- Iain Lane <laney@ubuntu.com>  Sat, 27 Feb 2010 20:35:10 +0000

agda (2.2.6-3) unstable; urgency=low

  [ Iain Lane ]
  * debian/rules, debian/watcher.sh: Add a ticker to the build to prevent
    timeouts on some arches. This was taken from the GHC6 source package and
    modified a bit to add some rudimentary locking. Previously the build was
    timing out on some slow arches (armel, mips*) but does actually make
    progress and complete when given enough time
  * debian/control:
    + Add field ${haskell:Provides} to -dev and -prof packages in preparation
      the upcoming GHC6/haskell-devscripts uploads into unstable
    + Standards-Version bump to 3.8.4, no changes required

  [ Marco Túlio Gontijo e Silva ]
  * debian/control: Remove unneeded Build-Depends: on libghc6-utf8-
    string-*.
  * debian/control: Bump version of haskell-devscripts on Build-Depends
    to 0.7.  Remove versioned Build-Depends: of ghc6* and remove
    hscolour and haddock from Build-Depends:.
  * debian/control: Split Build-Depends in Buid-Depends-Indep:.
  * debian/control: Use all haskell: variables.
  * debian/watch: Use format that downloads current version and checks
    for new versions.

 -- Marco Túlio Gontijo e Silva <marcot@debian.org>  Sat, 20 Feb 2010 20:12:57 -0200

agda (2.2.6-2) unstable; urgency=low

  * debian/control: Set priority to extra per archive overrides
  * debian/copyright: Update upstream source to a more generic location 
  * debian/rules, debian/libghc6-agda-dev.install: Install Agda.css, needed
    to generate HTML documentation.

 -- Iain Lane <laney@ubuntu.com>  Sun, 10 Jan 2010 11:29:17 +0000

agda (2.2.6-1) unstable; urgency=low

  * New upstream release 2.2.6, for headlines please see:
    http://wiki.portal.chalmers.se/agda/pmwiki.php?n=Main.Version-2-2-6
  * debian/control
    + Bump standards-version to 3.8.3, no changes
    + Fix Vcs-Git to point to correct URL
    + Update build-depends for new upstream release
    + Undo arch/indep split per current pkg-haskell practice
    + Add Homepage field
  * debian/copyright: Fix encoding to UTF-8 (thanks Lintian) 
  * debian/README.source: Remove, no repacking so not necessary any more 
  * debian/50agda.el:
    + Only load file if it exists, prevents a non-intrusive emacs warning
      where 50agda.el is left on system when package is removed. 
      (Closes: #559197). 
    + Do not load file on XEmacs — agda-mode is not compatible with XEmacs.

 -- Iain Lane <laney@ubuntu.com>  Tue, 05 Jan 2010 23:43:20 +0000

agda (2.2.4+dfsg-1) unstable; urgency=low

  * New upstream release 2.2.4.
  * Repacked to fix a couple of DFSG problems, see debian/README.source for
    more information.
  * debian/copyright: Update, add missing copyright holders.
  * debian/control: Move ghc6-doc, haddock to Build-Depends. Move -doc
    packages to build-depends-indep.

 -- Iain Lane <laney@ubuntu.com>  Mon, 20 Jul 2009 19:49:41 +0100

agda (2.2.2-1) unstable; urgency=low

  * Initial packaging (Closes: #522924)
  * With thanks to Marco Túlio Gontijo e Silva and Joachim Breitner for
    their helpful comments

 -- Iain Lane <laney@ubuntu.com>  Wed, 20 May 2009 16:08:07 +0100

=== debian/control ===
Source: agda
Priority: extra
Section: haskell
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders: Iain Lane <laney@ubuntu.com>
Build-Depends: debhelper (>= 7.0),
               haskell-devscripts (>= 0.7),
               cdbs (>> 0.4.58),
               ghc6,
               libghc6-quickcheck2-dev (>= 2.1.0.2),
               libghc6-quickcheck2-dev (<< 2.2.0.0),
               libghc6-binary-dev (>= 0.4.4),
               libghc6-binary-dev (<< 0.6),
               libghc6-haskeline-dev (>= 0.3),
               libghc6-haskeline-dev (<< 0.7),
               libghc6-haskell-src-dev (>= 1.0.1.1),
               libghc6-haskell-src-dev (<< 2),
               libghc6-mtl-dev (>= 1.1),
               libghc6-mtl-dev (<< 2),
               libghc6-xhtml-dev (>= 3000.2),
               libghc6-xhtml-dev (<< 3000.3),
               libghc6-zlib-dev (>= 0.4.0.1),
               libghc6-zlib-dev (<< 1),
               happy (>= 1.15),
               happy (<< 2),
               alex (>= 2.0.1),
               alex (<< 3),
               libncurses5-dev
Build-Depends-Indep: ghc6-doc,
                     libghc6-quickcheck2-doc (>= 2.1.0.2),
                     libghc6-quickcheck2-doc (<< 2.2.0.0),
                     libghc6-binary-doc (>= 0.4.4),
                     libghc6-binary-doc (<< 0.6),
                     libghc6-haskeline-doc (>= 0.3),
                     libghc6-haskeline-doc (<< 0.7),
                     libghc6-haskell-src-doc (>= 1.0.1.1),
                     libghc6-haskell-src-doc (<< 2),
                     libghc6-mtl-doc (>= 1.1),
                     libghc6-mtl-doc (<< 2),
                     libghc6-terminfo-doc,
                     libghc6-xhtml-doc (>= 3000.2),
                     libghc6-xhtml-doc (<< 3000.3),
                     libghc6-zlib-doc (>= 0.4.0.1),
                     libghc6-zlib-doc (<< 1)
Standards-Version: 3.8.4
Vcs-Browser: http://git.debian.org/?p=pkg-haskell/agda.git;a=summary
Vcs-Git: git://git.debian.org/git/pkg-haskell/agda.git
Homepage: http://wiki.portal.chalmers.se/agda/

Package: libghc6-agda-dev
Architecture: any
Section: haskell
Depends: ${haskell:Depends},
         ${misc:Depends},
Recommends: ${haskell:Recommends}
Suggests: ${haskell:Suggests}
Provides: ${haskell:Provides}
Description: a dependently typed functional programming language - development libraries
 Agda is a dependently typed functional programming language: It has inductive
 families, which are like Haskell's GADTs, but they can be indexed by values and
 not just types. It also has parameterised modules, mixfix operators, Unicode
 characters, and an interactive Emacs interface (the type checker can assist in
 the development of your code).
 .
 Agda is also a proof assistant: It is an interactive system for writing and
 checking proofs. Agda is based on intuitionistic type theory, a foundational
 system for constructive mathematics developed by the Swedish logician Per
 Martin-Löf. It has many similarities with other proof assistants based on
 dependent types, such as Coq, Epigram and NuPRL.
 .
 This package contains the normal library files.

Package: libghc6-agda-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}, ${haskell:Depends}
Recommends: ${haskell:Recommends}
Suggests: ${haskell:Suggests}
Replaces: haskell-agda-doc (<< 2.2.6-5)
Conflicts: haskell-agda-doc (<< 2.2.6-5)
Provides: haskell-agda-doc
Description: a dependently typed functional programming language - documentation
 Agda is a dependently typed functional programming language: It has inductive
 families, which are like Haskell's GADTs, but they can be indexed by values and
 not just types. It also has parameterised modules, mixfix operators, Unicode
 characters, and an interactive Emacs interface (the type checker can assist in
 the development of your code).
 .
 Agda is also a proof assistant: It is an interactive system for writing and
 checking proofs. Agda is based on intuitionistic type theory, a foundational
 system for constructive mathematics developed by the Swedish logician Per
 Martin-Löf. It has many similarities with other proof assistants based on
 dependent types, such as Coq, Epigram and NuPRL.
 .
 This package contains the documentation files.

Package: agda-mode
Architecture: all
Section: misc
Depends: ${shlibs:Depends},
         ${haskell:Depends},
         ${misc:Depends},
         emacs | emacsen,
         haskell-mode,
         libghc6-agda-dev (>= ${source:Version}),
         libghc6-agda-dev (<< ${source:Version}.1~)
Description: the emacs mode for Agda
 Agda is a dependently typed functional programming language: It has inductive
 families, which are like Haskell's GADTs, but they can be indexed by values and
 not just types. It also has parameterised modules, mixfix operators, Unicode
 characters, and an interactive Emacs interface (the type checker can assist in
 the development of your code).
 .
 Agda is also a proof assistant: It is an interactive system for writing and
 checking proofs. Agda is based on intuitionistic type theory, a foundational
 system for constructive mathematics developed by the Swedish logician Per
 Martin-Löf. It has many similarities with other proof assistants based on
 dependent types, such as Coq, Epigram and NuPRL.
 .
 This package contains the emacs interactive development mode for Agda. This
 mode is the preferred way to write Agda code, and offers features such as
 iterative development, refinement, case analysis and so on.

=== debian/rules ===
#!/usr/bin/make -f
DEB_BUILD_DEPENDENCIES = build-arch

DEB_SETUP_GHC6_CONFIGURE_ARGS := --datadir='/usr/share' --datasubdir='libghc6-agda-dev'

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/hlibrary.mk

## agda 2.2.10

=== debian/changelog ===
agda (2.2.10-4) unstable; urgency=low

  * [16d953e] Remove old left-around patches
  * [af671fe] Explicitly add haskell-mode directory to load path.
    Thanks to Joey Capper for discovering the bug.
  * [6fa096d] Update to use my d.o email address
  * [f228ca0] Add an alexGetByte function for alex-3.0 compatibility

 -- Iain Lane <laney@debian.org>  Sat, 03 Sep 2011 23:11:17 +0100

agda (2.2.10-3) unstable; urgency=low

  * Extend haskell-src-exts dependency range to include 0.11.* 

 -- Joachim Breitner <nomeata@debian.org>  Fri, 17 Jun 2011 10:38:21 +0200

agda (2.2.10-2) unstable; urgency=low

  * Adjust conflict on haskell-agda-doc to exclude the dummy package (Closes:
    #629572)

 -- Joachim Breitner <nomeata@debian.org>  Tue, 07 Jun 2011 23:57:04 +0200

agda (2.2.10-1) unstable; urgency=low

  * [60c4b8a] Imported Upstream version 2.2.10
  * [81c6857] Add haskell-src-exts BD
  * [d0ce959] Add QuickCheck BDs
  * [5c875b0] Update short descriptions to reflect best practice
  * [705223c] d/copyright: Update copyright years
  * [ee8a4bc] GHC6 → GHC, for GHC 7 transition
  * [12d4e49] Standards-Version bump to 3.9.2, no changes required
  * [9244cc3] Add 'agda' meta package
  * [c28c44c] Relax BD on src-exts
  * [86be090] Backport upstream patch to add syb-0.3 compatibility
  * [828c999] Lexer: Compatibility with the new GHC
  * [db55ca5] Clean up some autogenerated files

 -- Iain Lane <laney@ubuntu.com>  Thu, 19 May 2011 13:43:17 +0100

agda (2.2.8-1) experimental; urgency=low

  * [ec6cfda] Imported Upstream version 2.2.8
  * [597149f] Update emacs loading script to explicitly load haskell-
    ghci. If this is not present, then agda-mode will error out
    indicating that haskell-ghci is not available.
  * [b16f978] Standards-Version → 3.9.1, no changes required

 -- Iain Lane <laney@ubuntu.com>  Sat, 11 Dec 2010 15:39:21 +0000

=== debian/control ===
Source: agda
Priority: extra
Section: haskell
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders: Iain Lane <laney@debian.org>
Build-Depends: debhelper (>= 7.0),
               haskell-devscripts (>= 0.8),
               cdbs (>> 0.4.58),
               ghc,
               libghc-binary-dev (>= 0.4.4),
               libghc-binary-dev (<< 0.6),
               libghc-haskeline-dev (>= 0.3),
               libghc-haskeline-dev (<< 0.7),
               libghc-haskell-src-dev (>= 1.0.1.1),
               libghc-haskell-src-dev (<< 2),
               libghc-mtl-dev (>= 2.0),
               libghc-mtl-dev (<< 3),
               libghc-xhtml-dev (>= 3000.2),
               libghc-xhtml-dev (<< 3000.3),
               libghc-zlib-dev (>= 0.4.0.1),
               libghc-zlib-dev (<< 1),
               libghc-src-exts-dev (>= 1.9.6),
               libghc-src-exts-dev (<< 1.12),
               libghc-quickcheck2-dev (>= 2.3),
               libghc-quickcheck2-dev (<< 2.5),
               libghc-syb-dev (>= 0.1),
               libghc-syb-dev (<< 0.4),
               happy (>= 1.15),
               happy (<< 2),
               alex (>= 2.0.1),
               libncurses5-dev
Build-Depends-Indep: ghc-doc,
                     libghc-binary-doc (>= 0.4.4),
                     libghc-binary-doc (<< 0.6),
                     libghc-haskeline-doc (>= 0.3),
                     libghc-haskeline-doc (<< 0.7),
                     libghc-haskell-src-doc (>= 1.0.1.1),
                     libghc-haskell-src-doc (<< 2),
                     libghc-mtl-doc (>= 2.0),
                     libghc-mtl-doc (<< 3),
                     libghc-terminfo-doc,
                     libghc-xhtml-doc (>= 3000.2),
                     libghc-xhtml-doc (<< 3000.3),
                     libghc-zlib-doc (>= 0.4.0.1),
                     libghc-zlib-doc (<< 1),
                     libghc-src-exts-doc (>= 1.9.6),
                     libghc-src-exts-doc (<< 1.12),
                     libghc-quickcheck2-doc (>= 2.3),
                     libghc-quickcheck2-doc (<< 2.5),
                     libghc-syb-doc (>= 0.1),
                     libghc-syb-doc (<< 0.4),
Standards-Version: 3.9.2
Vcs-Browser: http://git.debian.org/?p=pkg-haskell/agda.git;a=summary
Vcs-Git: git://git.debian.org/git/pkg-haskell/agda.git
Homepage: http://wiki.portal.chalmers.se/agda/

Package: libghc-agda-dev
Architecture: any
Section: haskell
Depends: ${haskell:Depends},
         ${misc:Depends},
Recommends: ${haskell:Recommends}
Suggests: ${haskell:Suggests}
Provides: ${haskell:Provides}
Description: dependently typed functional programming language - development libraries
 Agda is a dependently typed functional programming language: It has inductive
 families, which are like Haskell's GADTs, but they can be indexed by values and
 not just types. It also has parameterised modules, mixfix operators, Unicode
 characters, and an interactive Emacs interface (the type checker can assist in
 the development of your code).
 .
 Agda is also a proof assistant: It is an interactive system for writing and
 checking proofs. Agda is based on intuitionistic type theory, a foundational
 system for constructive mathematics developed by the Swedish logician Per
 Martin-Löf. It has many similarities with other proof assistants based on
 dependent types, such as Coq, Epigram and NuPRL.
 .
 This package contains the normal library files.

Package: libghc-agda-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}, ${haskell:Depends}
Recommends: ${haskell:Recommends}
Suggests: ${haskell:Suggests}
Replaces: haskell-agda-doc
Conflicts: haskell-agda-doc (<< 2.2.6-5)
Provides: haskell-agda-doc
Description: dependently typed functional programming language - documentation
 Agda is a dependently typed functional programming language: It has inductive
 families, which are like Haskell's GADTs, but they can be indexed by values and
 not just types. It also has parameterised modules, mixfix operators, Unicode
 characters, and an interactive Emacs interface (the type checker can assist in
 the development of your code).
 .
 Agda is also a proof assistant: It is an interactive system for writing and
 checking proofs. Agda is based on intuitionistic type theory, a foundational
 system for constructive mathematics developed by the Swedish logician Per
 Martin-Löf. It has many similarities with other proof assistants based on
 dependent types, such as Coq, Epigram and NuPRL.
 .
 This package contains the documentation files.

Package: agda-mode
Architecture: all
Section: misc
Depends: ${shlibs:Depends},
         ${haskell:Depends},
         ${misc:Depends},
         emacs | emacsen,
         haskell-mode,
         libghc-agda-dev (>= ${source:Version}),
         libghc-agda-dev (<< ${source:Version}.1~)
Description: dependently typed functional programming language — emacs mode
 Agda is a dependently typed functional programming language: It has inductive
 families, which are like Haskell's GADTs, but they can be indexed by values and
 not just types. It also has parameterised modules, mixfix operators, Unicode
 characters, and an interactive Emacs interface (the type checker can assist in
 the development of your code).
 .
 Agda is also a proof assistant: It is an interactive system for writing and
 checking proofs. Agda is based on intuitionistic type theory, a foundational
 system for constructive mathematics developed by the Swedish logician Per
 Martin-Löf. It has many similarities with other proof assistants based on
 dependent types, such as Coq, Epigram and NuPRL.
 .
 This package contains the emacs interactive development mode for Agda. This
 mode is the preferred way to write Agda code, and offers features such as
 iterative development, refinement, case analysis and so on.

Package: agda
Architecture: all
Section: misc
Depends: ${misc:Depends},
         libghc-agda-dev,
         agda-mode,
         agda-bin,
         agda-stdlib,
         agda-stdlib-doc
Description: dependently typed functional programming language
 Agda is a dependently typed functional programming language: It has inductive
 families, which are like Haskell's GADTs, but they can be indexed by values and
 not just types. It also has parameterised modules, mixfix operators, Unicode
 characters, and an interactive Emacs interface (the type checker can assist in
 the development of your code).
 .
 Agda is also a proof assistant: It is an interactive system for writing and
 checking proofs. Agda is based on intuitionistic type theory, a foundational
 system for constructive mathematics developed by the Swedish logician Per
 Martin-Löf. It has many similarities with other proof assistants based on
 dependent types, such as Coq, Epigram and NuPRL.
 .
 This is a meta package which provides Agda's emacs mode, executable, standard
 library and its documentation.

=== debian/rules ===
#!/usr/bin/make -f
DEB_BUILD_DEPENDENCIES = build-arch

DEB_SETUP_GHC6_CONFIGURE_ARGS := --datadir='/usr/share' --datasubdir='libghc-agda-dev'

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/hlibrary.mk
